// @ts-check

import { world, system, Player } from '@minecraft/server';
import config from './config.js';

const r = "§r";

/**
 * @param { Player } sender
 * @param { string } message
 */
const teamChatFunc = function(sender, message){
    if(sender.hasTag("aqua")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("aqua")) player.sendMessage("-> §b[aqua] §r<§b" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("black")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("black")) player.sendMessage("-> §0[black] §r<§0" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("blue")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("blue")) player.sendMessage("-> §9[blue] §r<§9" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("dark_aqua")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("dark_aqua")) player.sendMessage("-> §3[dark_aqua] §r<§3" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("dark_blue")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("dark_blue")) player.sendMessage("-> §1[dark_blue] §r<§1" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("dark_grey")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("dark_grey")) player.sendMessage("-> §8[dark_grey] §r<§8" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("dark_green")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("dark_green")) player.sendMessage("-> §2[dark_green] §r<§2" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("dark_purple")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("dark_purple")) player.sendMessage("-> §5[dark_purple] §r<§5" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("dark_red")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("dark_red")) player.sendMessage("-> §4[dark_red] §r<§4" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("gold")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("gold")) player.sendMessage("-> §6[gold] §r<§6" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("grey")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("grey")) player.sendMessage("-> §7[grey] §r<§7" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("green")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("green")) player.sendMessage("-> §a[green] §r<§a" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("light_purple")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("light_purple")) player.sendMessage("-> §d[light_purple] §r<§d" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("red")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("red")) player.sendMessage("-> §c[red] §r<§c" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("white")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("white")) player.sendMessage("-> §f[white] §r<§f" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else if(sender.hasTag("yellow")){
        world.getPlayers().forEach((player)=>{
            if(player.hasTag("yellow")) player.sendMessage("-> §e[yellow] §r<§e" + sender.name + "§r> " + message.replace(config.teamChatPrefix,""));
        });
    }else{
        sender.sendMessage("§cチームに所属していないため、チームチャットは利用できません！");
    }
};

system.runInterval(()=>{
    world.getPlayers().forEach((player)=>{
        if(player.hasTag("aqua")) player.nameTag = "§b" + player.name + r;
        else if(player.hasTag("black")) player.nameTag = "§0" + player.name + r;
        else if(player.hasTag("blue")) player.nameTag = "§9" + player.name + r;
        else if(player.hasTag("dark_aqua")) player.nameTag = "§3" + player.name + r;
        else if(player.hasTag("dark_blue")) player.nameTag = "§1" + player.name + r;
        else if(player.hasTag("dark_gray")) player.nameTag = "§8" + player.name + r;
        else if(player.hasTag("dark_green")) player.nameTag = "§2" + player.name + r;
        else if(player.hasTag("dark_purple")) player.nameTag = "§5" + player.name + r;
        else if(player.hasTag("dark_red")) player.nameTag = "§4" + player.name + r;
        else if(player.hasTag("gold")) player.nameTag = "§6" + player.name + r;
        else if(player.hasTag("gray")) player.nameTag = "§7" + player.name + r;
        else if(player.hasTag("green")) player.nameTag = "§a" + player.name + r;
        else if(player.hasTag("light_purple")) player.nameTag = "§d" + player.name + r;
        else if(player.hasTag("red")) player.nameTag = "§c" + player.name + r;
        else if(player.hasTag("white")) player.nameTag = "§f" + player.name + r;
        else if(player.hasTag("yellow")) player.nameTag = "§e" + player.name + r;
        else player.nameTag = player.name;
    });
},20);

world.afterEvents.playerSpawn.subscribe((ev) => {
    const { initialSpawn, player } = ev;
    
    if(initialSpawn == true){
        player.setDynamicProperty("AutoTeamChat",false);
    }
});

world.beforeEvents.chatSend.subscribe((ev) => {
    const { sender, message } = ev;
    const autoTeamChat = sender.getDynamicProperty("AutoTeamChat");
    ev.cancel = true;

    if(message == "!chat"){
        sender.sendMessage("§aチームチャットの設定を切り替えました");

        if(autoTeamChat){
            sender.setDynamicProperty("AutoTeamChat",false);
            sender.sendMessage("§6現在の設定:手動");
        }else{
            sender.setDynamicProperty("AutoTeamChat",true);
            sender.sendMessage("§6現在の設定:自動");
        }
    }else{
        //自動
        if(autoTeamChat){
            if(message.startsWith(config.teamChatPrefix)){
                world.sendMessage("<" + sender.nameTag + "> " + message.replace(config.teamChatPrefix,""));
            }else{
                teamChatFunc(sender, message);
            }
        }
        
        //手動
        else{
            if(message.startsWith(config.teamChatPrefix)){
                teamChatFunc(sender, message);
            }else{
                world.sendMessage("<" + sender.nameTag + "> " + message.replace(config.teamChatPrefix,""));
            }
        }
    }
});